package skype_saver;

import com.skype.*;
import java.io.*;
import java.util.*;
import java.text.*;
import java.nio.charset.*;


public class Main {
	private enum Type
	{
		SETTOPIC, SAID, ADDEDMEMBERS, SAWMEMBERS, CREATEDCHATWITH, LEFT, EMOTED, UNKNOWN;
	}

	private static boolean windows;

	public static void main(String[] args) {
		if(args.length==1) {
			String arg = args[0];
			if(arg.equals("-h")) {
				System.out.println("usage:\n"+
						"\tjava -jar skype_saver.jar [params]\n"+
						"\t-h - get this help\n"+
						"\t-w - output in cp1251\n"+
						"\t-u - output in utf8 (default)\n");
				return;
			}
			if(arg.equals("-w")) {
				windows = true;
			} else {
				windows = false;
			}
		}
		try
		{
			String myId = Skype.getProfile().getId();
			System.out.println("MyID: "+myId);
			//Skype.setDebug(true);
			System.out.println("Version: "+Skype.getVersion());
			System.out.println();
			Chat[] cc = Skype.getAllChats();
			System.out.println("Chat count: "+cc.length);
			for(int i=0;i<cc.length;i++)
			{
				Chat c = cc[i];

				try
				{
					File f = new File(int2str(i,3)+".txt");
					f.createNewFile();
					FileOutputStream fw = new FileOutputStream(f);
					/*fw.write("Title: "+c.getWindowTitle()+"\n");
					fw.write("Users: ");
					//System.out.print(c.getWindowTitle()+": ");
					User[] uu = c.getAllMembers();
					for(int j=0;j<uu.length;j++)
					{
						User u = uu[j];
						System.out.print(u.getId()+" ");
						fw.write(u.getId()+" ");
					}
					fw.write("\n\n\n");
					 */
					System.out.print("chat "+i+"...");
					ChatMessage[] mm = c.getAllChatMessages();
					for(int j=mm.length-1;j>=0;j--)
					{
						ChatMessage m = mm[j];
						String sender = m.getSenderDisplayName();
						String senderId = m.getSenderId();
						String mes = m.getContent();
						Date tm = m.getTime();
						//ChatMessage.Type tp = m.getType();
						//if(m.getType()==ChatMessage.Type.SAID)
						//{
						if(!mes.isEmpty())
						{
							if(senderId.equals(myId))
							{
								fw.write(getMessageArray("-------------------------------------->-\n"));
							}
							else
							{
								fw.write(getMessageArray("--------------------------------------<-\n"));
							}
							fw.write(getMessageArray(sender+" ("+getTimeString(tm)+")\n"));
							//fw.write(m.getType()+"\n");
							fw.write(getMessageArray(mes+"\n\n"));
						}
						//}
					}
					System.out.println("done");
					fw.close();
				}
				catch(Exception e)
				{
					System.out.println("ERROR: "+e.getMessage());
					e.printStackTrace();
				}
			}
		}
		catch(SkypeException e)
		{
			System.out.println("ERROR: "+e.getMessage());
		}
    }

	private static String getTimeString(Date d)
	{
		SimpleDateFormat f = new SimpleDateFormat("HH:mm:ss dd/MM/yyyy");
		return f.format(d);
	}

	private static byte[] getMessageArray(String mes)
	{
		if(windows) {
			mes = mes.replaceAll("\n", "\r\n");
			byte[] bf = mes.getBytes(Charset.forName("cp1251"));
			return bf;
		} else {
			byte[] bf = mes.getBytes(Charset.forName("utf-8"));
			return bf;
		}
	}

	private static String int2str(int a, int len) {
		String s = Integer.toString(a);
		while(s.length()<len) {
			s = "0" + s;
		}
		return s;
	}
}